/** @license
The MIT License (MIT)

Copyright (c) 2016 Marijn Haverbeke <marijnh@gmail.com> and others
Copyright (c) 2016 Michael Zhou <zhoumotongxue008@gmail.com>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/
'use strict';(function(m){"object"==typeof exports&&"object"==typeof module?m(require("../../lib/codemirror")):"function"==typeof define&&define.amd?define(["../../lib/codemirror"],m):m(CodeMirror)})(function(m){function p(b,a,c){return"_"===c?b.eat("_")?g(b,a,"italic",/__/,2):g(b,a,"em",/_/,1):"*"===c?b.eat("*")?g(b,a,"bold",/\*\*/,2):g(b,a,"strong",/\*/,1):"["===c?(b.match(/\d+\]/)&&(a.footCite=!0),h(a)):"("===c&&b.match(/^(r|tm|c)\)/)?l(a,k.specialChar):"<"===c&&b.match(/(\w+)[^>]+>[^<]+<\/\1>/)?
l(a,k.html):"?"===c&&b.eat("?")?g(b,a,"cite",/\?\?/,2):"="===c&&b.eat("=")?g(b,a,"notextile",/==/,2):"-"!==c||b.eat("-")?"+"===c?g(b,a,"addition",/\+/,1):"~"===c?g(b,a,"sub",/~/,1):"^"===c?g(b,a,"sup",/\^/,1):"%"===c?g(b,a,"span",/%/,1):"@"===c?g(b,a,"code",/@/,1):"!"===c?(a=g(b,a,"image",/(?:\([^\)]+\))?!/,1),b.match(/^:\S+/),a):h(a):g(b,a,"deletion",/-/,1)}function g(b,a,c,d,e){e=b.pos>e?b.string.charAt(b.pos-e-1):null;var g=b.peek();if(a[c]){if((!g||/\W/.test(g))&&e&&/\S/.test(e))return b=h(a),
a[c]=!1,b}else(!e||/\W/.test(e))&&g&&/\S/.test(g)&&b.match(new RegExp("^.*\\S"+d.source+"(?:\\W|$)"),!1)&&(a[c]=!0,a.mode=f.attributes);return h(a)}function h(b){var a=n(b);if(a)return a;a=[];b.layoutType&&a.push(k[b.layoutType]);a=a.concat(q(b,"addition","bold","cite","code","deletion","em","footCite","image","italic","link","span","strong","sub","sup","table","tableHeading"));"header"===b.layoutType&&a.push(k.header+"-"+b.header);return a.length?a.join(" "):null}function n(b){var a=b.layoutType;
switch(a){case "notextile":case "code":case "pre":return k[a];default:return b.notextile?k.notextile+(a?" "+k[a]:""):null}}function l(b,a){var c=n(b);if(c)return c;b=h(b);return a?b?b+" "+a:a:b}function q(b){for(var a=[],c=1;c<arguments.length;++c)b[arguments[c]]&&a.push(k[arguments[c]]);return a}function r(b){var a=b.spanningLayout,c=b.layoutType,d;for(d in b)b.hasOwnProperty(d)&&delete b[d];b.mode=f.newLayout;a&&(b.layoutType=c,b.spanningLayout=!0)}function e(b){return d.cache[b]||(d.cache[b]=d.createRe(b))}
var k={addition:"positive",attributes:"attribute",bold:"strong",cite:"keyword",code:"atom",definitionList:"number",deletion:"negative",div:"punctuation",em:"em",footnote:"variable",footCite:"qualifier",header:"header",html:"comment",image:"string",italic:"em",link:"link",linkDefinition:"link",list1:"variable-2",list2:"variable-3",list3:"keyword",notextile:"string-2",pre:"operator",p:"property",quote:"bracket",span:"quote",specialChar:"tag",strong:"strong",sub:"builtin",sup:"builtin",table:"variable-3",
tableHeading:"operator"},d={cache:{},single:{bc:"bc",bq:"bq",definitionList:/- [^(?::=)]+:=+/,definitionListEnd:/.*=:\s*$/,div:"div",drawTable:/\|.*\|/,foot:/fn\d+/,header:/h[1-6]/,html:/\s*<(?:\/)?(\w+)(?:[^>]+)?>(?:[^<]+<\/\1>)?/,link:/[^"]+":\S/,linkDefinition:/\[[^\s\]]+\]\S+/,list:/(?:#+|\*+)/,notextile:"notextile",para:"p",pre:"pre",table:"table",tableCellAttributes:/[\/\\]\d+/,tableHeading:/\|_\./,tableText:/[^"_\*\[\(\?\+~\^%@|-]+/,text:/[^!"_=\*\[\(<\?\+~\^%@-]+/},attributes:{align:/(?:<>|<|>|=)/,
selector:/\([^\(][^\)]+\)/,lang:/\[[^\[\]]+\]/,pad:/(?:\(+|\)+){1,2}/,css:/\{[^\}]+\}/},createRe:function(b){switch(b){case "drawTable":return d.makeRe("^",d.single.drawTable,"$");case "html":return d.makeRe("^",d.single.html,"(?:",d.single.html,")*","$");case "linkDefinition":return d.makeRe("^",d.single.linkDefinition,"$");case "listLayout":return d.makeRe("^",d.single.list,e("allAttributes"),"*\\s+");case "tableCellAttributes":return d.makeRe("^",d.choiceRe(d.single.tableCellAttributes,e("allAttributes")),
"+\\.");case "type":return d.makeRe("^",e("allTypes"));case "typeLayout":return d.makeRe("^",e("allTypes"),e("allAttributes"),"*\\.\\.?","(\\s+|$)");case "attributes":return d.makeRe("^",e("allAttributes"),"+");case "allTypes":return d.choiceRe(d.single.div,d.single.foot,d.single.header,d.single.bc,d.single.bq,d.single.notextile,d.single.pre,d.single.table,d.single.para);case "allAttributes":return d.choiceRe(d.attributes.selector,d.attributes.css,d.attributes.lang,d.attributes.align,d.attributes.pad);
default:return d.makeRe("^",d.single[b])}},makeRe:function(){for(var b="",a=0;a<arguments.length;++a)var c=arguments[a],b=b+("string"===typeof c?c:c.source);return new RegExp(b)},choiceRe:function(){for(var b=[arguments[0]],a=1;a<arguments.length;++a)b[2*a-1]="|",b[2*a]=arguments[a];b.unshift("(?:");b.push(")");return d.makeRe.apply(null,b)}},f={newLayout:function(b,a){if(b.match(e("typeLayout"),!1))return a.spanningLayout=!1,(a.mode=f.blockType)(b,a);var c;n(a)||(b.match(e("listLayout"),!1)?c=f.list:
b.match(e("drawTable"),!1)?c=f.table:b.match(e("linkDefinition"),!1)?c=f.linkDefinition:b.match(e("definitionList"))?c=f.definitionList:b.match(e("html"),!1)&&(c=f.html));return(a.mode=c||f.text)(b,a)},blockType:function(b,a){var c;a.layoutType=null;if(c=b.match(e("type")))b=c[0];else return(a.mode=f.text)(b,a);(c=b.match(e("header")))?(a.layoutType="header",a.header=parseInt(c[0][1])):b.match(e("bq"))?a.layoutType="quote":b.match(e("bc"))?a.layoutType="code":b.match(e("foot"))?a.layoutType="footnote":
b.match(e("notextile"))?a.layoutType="notextile":b.match(e("pre"))?a.layoutType="pre":b.match(e("div"))?a.layoutType="div":b.match(e("table"))&&(a.layoutType="table");a.mode=f.attributes;return h(a)},text:function(b,a){if(b.match(e("text")))return h(a);var c=b.next();return'"'===c?(a.mode=f.link)(b,a):p(b,a,c)},attributes:function(b,a){a.mode=f.layoutLength;return b.match(e("attributes"))?l(a,k.attributes):h(a)},layoutLength:function(b,a){b.eat(".")&&b.eat(".")&&(a.spanningLayout=!0);a.mode=f.text;
return h(a)},list:function(b,a){b=b.match(e("list"));a.listDepth=b[0].length;b=(a.listDepth-1)%3;a.layoutType=b?1===b?"list2":"list3":"list1";a.mode=f.attributes;return h(a)},link:function(b,a){a.mode=f.text;return b.match(e("link"))?(b.match(/\S+/),l(a,k.link)):h(a)},linkDefinition:function(b,a){b.skipToEnd();return l(a,k.linkDefinition)},definitionList:function(b,a){b.match(e("definitionList"));a.layoutType="definitionList";b.match(/\s*$/)?a.spanningLayout=!0:a.mode=f.attributes;return h(a)},html:function(b,
a){b.skipToEnd();return l(a,k.html)},table:function(b,a){a.layoutType="table";return(a.mode=f.tableCell)(b,a)},tableCell:function(b,a){b.match(e("tableHeading"))?a.tableHeading=!0:b.eat("|");a.mode=f.tableCellAttributes;return h(a)},tableCellAttributes:function(b,a){a.mode=f.tableText;return b.match(e("tableCellAttributes"))?l(a,k.attributes):h(a)},tableText:function(b,a){return b.match(e("tableText"))?h(a):"|"===b.peek()?(a.mode=f.tableCell,h(a)):p(b,a,b.next())}};m.defineMode("textile",function(){return{startState:function(){return{mode:f.newLayout}},
token:function(b,a){b.sol()&&(a.mode=f.newLayout,a.tableHeading=!1,"definitionList"===a.layoutType&&a.spanningLayout&&b.match(e("definitionListEnd"),!1)&&(a.spanningLayout=!1));return a.mode(b,a)},blankLine:r}});m.defineMIME("text/x-textile","textile")});
